<?php

include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/admin/model/db.php");
include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/core/model/stats.php");
include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/core/model/email-signups.php");

// Create all tables

WPsite_Firebar_DB::createTable();
WPsite_Stats_FB::createTable();
WPsite_Email_Signups_FB::createTable();

// Check if multisite, if so then save as site option

if (is_multisite()) {
	$version = get_site_option(self::$prefix . 'version');
} else {
	$version = get_option(self::$prefix . 'version');
}

if ($version !== false) {

	// Restructure table to allow for international characters

	if (version_compare($version, '2.0.4', '<=') && version_compare(WPSITE_FIREBAR_VERSION_NUM, '2.0.4', '>=')) {

		global $wpdb;

		include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/admin/model/db.php");

		if ( !is_multisite() ) {

			// Alter character sets

			$query = $wpdb->query("ALTER TABLE `" . WPsite_Firebar_DB::getTableName() . "` CONVERT TO CHARACTER SET utf8 COLLATE utf8_unicode_ci;");

		} else {

		    $blog_ids = $wpdb->get_col( "SELECT blog_id FROM $wpdb->blogs" );
		    $original_blog_id = get_current_blog_id();

		    foreach ( $blog_ids as $blog_id ) {
		        switch_to_blog( $blog_id );

				// Alter character sets

				$query = $wpdb->query("ALTER TABLE `" . WPsite_Firebar_DB::getTableName() . "` CONVERT TO CHARACTER SET utf8 COLLATE utf8_unicode_ci;");

		    }

		    restore_current_blog();
		}
	}

	// Set all enable google font settings to true

	if (version_compare($version, '2.0.0', '<=') && version_compare(WPSITE_FIREBAR_VERSION_NUM, '2.0.0', '>=')) {

		global $wpdb;
		include_once(WPSITE_FIREBAR_PLUGIN_DIR . "/admin/model/db.php");
		$wpsite_firebar_db = new WPsite_Firebar_DB();

		$query = "SELECT * FROM `" . WPsite_Firebar_DB::getTableName() . "`";
	    $firebars = $wpdb->get_results($query,'ARRAY_A');

	    // Set enable google font setting to true

	    foreach ($firebars as $firebar) {

			$firebar['trigger']           	= unserialize($firebar['trigger']);
	        $firebar['social']  			= unserialize($firebar['social']);
			$firebar['news_letter']   		= unserialize($firebar['news_letter']);
			$firebar['text_link']     		= unserialize($firebar['text_link']);
			$firebar['args']          		= unserialize($firebar['args']);

			$firebar['args']['google_fonts'] = true;

			$wpsite_firebar_db->update_data($firebar);

	    }

	}

	// Add admin notice for update to 1.2 about new fonts and modify data structure

	if (version_compare($version, '1.2.5', '<=') && version_compare(WPSITE_FIREBAR_VERSION_NUM, '1.2.5', '>=')) {

		// Set transient for new admin notice

		set_transient(self::$prefix . 'admin_notice_mailchimp', '0', 0);
	}

	// Add admin notice for update to 1.2 about new fonts and modify data structure

	if (version_compare($version, '1.2', '<=') && version_compare(WPSITE_FIREBAR_VERSION_NUM, '1.2', '>=')) {

		// Set transient for new admin notice

		set_transient(self::$prefix . 'admin_notice_font', '0', 0);
	}
}

// Check if multisite, if so then save as site option

if (is_multisite()) {
	update_site_option(self::$prefix . 'version', WPSITE_FIREBAR_VERSION_NUM);
} else {
	update_option(self::$prefix . 'version', WPSITE_FIREBAR_VERSION_NUM);
}